r"""Wrapper for modal_pipe_interfaces.h

Generated with:
/usr/local/bin/ctypesgen -I/builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h -o /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/build64/python/pympa_types.py

Do not modify this file.
"""

__docformat__ = "restructuredtext"

# Begin preamble for Python v(3, 2)

import ctypes, os, sys
from ctypes import *

_int_types = (c_int16, c_int32)
if hasattr(ctypes, "c_int64"):
    # Some builds of ctypes apparently do not have c_int64
    # defined; it's a pretty good bet that these builds do not
    # have 64-bit pointers.
    _int_types += (c_int64,)
for t in _int_types:
    if sizeof(t) == sizeof(c_size_t):
        c_ptrdiff_t = t
del t
del _int_types


class UserString:
    def __init__(self, seq):
        if isinstance(seq, bytes):
            self.data = seq
        elif isinstance(seq, UserString):
            self.data = seq.data[:]
        else:
            self.data = str(seq).encode()

    def __bytes__(self):
        return self.data

    def __str__(self):
        return self.data.decode()

    def __repr__(self):
        return repr(self.data)

    def __int__(self):
        return int(self.data.decode())

    def __long__(self):
        return int(self.data.decode())

    def __float__(self):
        return float(self.data.decode())

    def __complex__(self):
        return complex(self.data.decode())

    def __hash__(self):
        return hash(self.data)

    def __cmp__(self, string):
        if isinstance(string, UserString):
            return cmp(self.data, string.data)
        else:
            return cmp(self.data, string)

    def __le__(self, string):
        if isinstance(string, UserString):
            return self.data <= string.data
        else:
            return self.data <= string

    def __lt__(self, string):
        if isinstance(string, UserString):
            return self.data < string.data
        else:
            return self.data < string

    def __ge__(self, string):
        if isinstance(string, UserString):
            return self.data >= string.data
        else:
            return self.data >= string

    def __gt__(self, string):
        if isinstance(string, UserString):
            return self.data > string.data
        else:
            return self.data > string

    def __eq__(self, string):
        if isinstance(string, UserString):
            return self.data == string.data
        else:
            return self.data == string

    def __ne__(self, string):
        if isinstance(string, UserString):
            return self.data != string.data
        else:
            return self.data != string

    def __contains__(self, char):
        return char in self.data

    def __len__(self):
        return len(self.data)

    def __getitem__(self, index):
        return self.__class__(self.data[index])

    def __getslice__(self, start, end):
        start = max(start, 0)
        end = max(end, 0)
        return self.__class__(self.data[start:end])

    def __add__(self, other):
        if isinstance(other, UserString):
            return self.__class__(self.data + other.data)
        elif isinstance(other, bytes):
            return self.__class__(self.data + other)
        else:
            return self.__class__(self.data + str(other).encode())

    def __radd__(self, other):
        if isinstance(other, bytes):
            return self.__class__(other + self.data)
        else:
            return self.__class__(str(other).encode() + self.data)

    def __mul__(self, n):
        return self.__class__(self.data * n)

    __rmul__ = __mul__

    def __mod__(self, args):
        return self.__class__(self.data % args)

    # the following methods are defined in alphabetical order:
    def capitalize(self):
        return self.__class__(self.data.capitalize())

    def center(self, width, *args):
        return self.__class__(self.data.center(width, *args))

    def count(self, sub, start=0, end=sys.maxsize):
        return self.data.count(sub, start, end)

    def decode(self, encoding=None, errors=None):  # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.decode(encoding, errors))
            else:
                return self.__class__(self.data.decode(encoding))
        else:
            return self.__class__(self.data.decode())

    def encode(self, encoding=None, errors=None):  # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.encode(encoding, errors))
            else:
                return self.__class__(self.data.encode(encoding))
        else:
            return self.__class__(self.data.encode())

    def endswith(self, suffix, start=0, end=sys.maxsize):
        return self.data.endswith(suffix, start, end)

    def expandtabs(self, tabsize=8):
        return self.__class__(self.data.expandtabs(tabsize))

    def find(self, sub, start=0, end=sys.maxsize):
        return self.data.find(sub, start, end)

    def index(self, sub, start=0, end=sys.maxsize):
        return self.data.index(sub, start, end)

    def isalpha(self):
        return self.data.isalpha()

    def isalnum(self):
        return self.data.isalnum()

    def isdecimal(self):
        return self.data.isdecimal()

    def isdigit(self):
        return self.data.isdigit()

    def islower(self):
        return self.data.islower()

    def isnumeric(self):
        return self.data.isnumeric()

    def isspace(self):
        return self.data.isspace()

    def istitle(self):
        return self.data.istitle()

    def isupper(self):
        return self.data.isupper()

    def join(self, seq):
        return self.data.join(seq)

    def ljust(self, width, *args):
        return self.__class__(self.data.ljust(width, *args))

    def lower(self):
        return self.__class__(self.data.lower())

    def lstrip(self, chars=None):
        return self.__class__(self.data.lstrip(chars))

    def partition(self, sep):
        return self.data.partition(sep)

    def replace(self, old, new, maxsplit=-1):
        return self.__class__(self.data.replace(old, new, maxsplit))

    def rfind(self, sub, start=0, end=sys.maxsize):
        return self.data.rfind(sub, start, end)

    def rindex(self, sub, start=0, end=sys.maxsize):
        return self.data.rindex(sub, start, end)

    def rjust(self, width, *args):
        return self.__class__(self.data.rjust(width, *args))

    def rpartition(self, sep):
        return self.data.rpartition(sep)

    def rstrip(self, chars=None):
        return self.__class__(self.data.rstrip(chars))

    def split(self, sep=None, maxsplit=-1):
        return self.data.split(sep, maxsplit)

    def rsplit(self, sep=None, maxsplit=-1):
        return self.data.rsplit(sep, maxsplit)

    def splitlines(self, keepends=0):
        return self.data.splitlines(keepends)

    def startswith(self, prefix, start=0, end=sys.maxsize):
        return self.data.startswith(prefix, start, end)

    def strip(self, chars=None):
        return self.__class__(self.data.strip(chars))

    def swapcase(self):
        return self.__class__(self.data.swapcase())

    def title(self):
        return self.__class__(self.data.title())

    def translate(self, *args):
        return self.__class__(self.data.translate(*args))

    def upper(self):
        return self.__class__(self.data.upper())

    def zfill(self, width):
        return self.__class__(self.data.zfill(width))


class MutableString(UserString):
    """mutable string objects

    Python strings are immutable objects.  This has the advantage, that
    strings may be used as dictionary keys.  If this property isn't needed
    and you insist on changing string values in place instead, you may cheat
    and use MutableString.

    But the purpose of this class is an educational one: to prevent
    people from inventing their own mutable string class derived
    from UserString and than forget thereby to remove (override) the
    __hash__ method inherited from UserString.  This would lead to
    errors that would be very hard to track down.

    A faster and better solution is to rewrite your program using lists."""

    def __init__(self, string=""):
        self.data = string

    def __hash__(self):
        raise TypeError("unhashable type (it is mutable)")

    def __setitem__(self, index, sub):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data):
            raise IndexError
        self.data = self.data[:index] + sub + self.data[index + 1 :]

    def __delitem__(self, index):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data):
            raise IndexError
        self.data = self.data[:index] + self.data[index + 1 :]

    def __setslice__(self, start, end, sub):
        start = max(start, 0)
        end = max(end, 0)
        if isinstance(sub, UserString):
            self.data = self.data[:start] + sub.data + self.data[end:]
        elif isinstance(sub, bytes):
            self.data = self.data[:start] + sub + self.data[end:]
        else:
            self.data = self.data[:start] + str(sub).encode() + self.data[end:]

    def __delslice__(self, start, end):
        start = max(start, 0)
        end = max(end, 0)
        self.data = self.data[:start] + self.data[end:]

    def immutable(self):
        return UserString(self.data)

    def __iadd__(self, other):
        if isinstance(other, UserString):
            self.data += other.data
        elif isinstance(other, bytes):
            self.data += other
        else:
            self.data += str(other).encode()
        return self

    def __imul__(self, n):
        self.data *= n
        return self


class String(MutableString, Union):

    _fields_ = [("raw", POINTER(c_char)), ("data", c_char_p)]

    def __init__(self, obj=""):
        if isinstance(obj, (bytes, UserString)):
            self.data = bytes(obj)
        else:
            self.raw = obj

    def __len__(self):
        return self.data and len(self.data) or 0

    def from_param(cls, obj):
        # Convert None or 0
        if obj is None or obj == 0:
            return cls(POINTER(c_char)())

        # Convert from String
        elif isinstance(obj, String):
            return obj

        # Convert from bytes
        elif isinstance(obj, bytes):
            return cls(obj)

        # Convert from str
        elif isinstance(obj, str):
            return cls(obj.encode())

        # Convert from c_char_p
        elif isinstance(obj, c_char_p):
            return obj

        # Convert from POINTER(c_char)
        elif isinstance(obj, POINTER(c_char)):
            return obj

        # Convert from raw pointer
        elif isinstance(obj, int):
            return cls(cast(obj, POINTER(c_char)))

        # Convert from c_char array
        elif isinstance(obj, c_char * len(obj)):
            return obj

        # Convert from object
        else:
            return String.from_param(obj._as_parameter_)

    from_param = classmethod(from_param)


def ReturnString(obj, func=None, arguments=None):
    return String.from_param(obj)


# As of ctypes 1.0, ctypes does not support custom error-checking
# functions on callbacks, nor does it support custom datatypes on
# callbacks, so we must ensure that all callbacks return
# primitive datatypes.
#
# Non-primitive return values wrapped with UNCHECKED won't be
# typechecked, and will be converted to c_void_p.
def UNCHECKED(type):
    if hasattr(type, "_type_") and isinstance(type._type_, str) and type._type_ != "P":
        return type
    else:
        return c_void_p


# ctypes doesn't have direct support for variadic functions, so we have to write
# our own wrapper class
class _variadic_function(object):
    def __init__(self, func, restype, argtypes, errcheck):
        self.func = func
        self.func.restype = restype
        self.argtypes = argtypes
        if errcheck:
            self.func.errcheck = errcheck

    def _as_parameter_(self):
        # So we can pass this variadic function as a function pointer
        return self.func

    def __call__(self, *args):
        fixed_args = []
        i = 0
        for argtype in self.argtypes:
            # Typecheck what we can
            fixed_args.append(argtype.from_param(args[i]))
            i += 1
        return self.func(*fixed_args + list(args[i:]))


def ord_if_char(value):
    """
    Simple helper used for casts to simple builtin types:  if the argument is a
    string type, it will be converted to it's ordinal value.

    This function will raise an exception if the argument is string with more
    than one characters.
    """
    return ord(value) if (isinstance(value, bytes) or isinstance(value, str)) else value

# End preamble

_libs = {}
_libdirs = []

# Begin loader

# ----------------------------------------------------------------------------
# Copyright (c) 2008 David James
# Copyright (c) 2006-2008 Alex Holkner
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of pyglet nor the names of its
#    contributors may be used to endorse or promote products
#    derived from this software without specific prior written
#    permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# ----------------------------------------------------------------------------

import os.path, re, sys, glob
import platform
import ctypes
import ctypes.util


def _environ_path(name):
    if name in os.environ:
        return os.environ[name].split(":")
    else:
        return []


class LibraryLoader(object):
    # library names formatted specifically for platforms
    name_formats = ["%s"]

    class Lookup(object):
        mode = ctypes.DEFAULT_MODE

        def __init__(self, path):
            super(LibraryLoader.Lookup, self).__init__()
            self.access = dict(cdecl=ctypes.CDLL(path, self.mode))

        def get(self, name, calling_convention="cdecl"):
            if calling_convention not in self.access:
                raise LookupError(
                    "Unknown calling convention '{}' for function '{}'".format(
                        calling_convention, name
                    )
                )
            return getattr(self.access[calling_convention], name)

        def has(self, name, calling_convention="cdecl"):
            if calling_convention not in self.access:
                return False
            return hasattr(self.access[calling_convention], name)

        def __getattr__(self, name):
            return getattr(self.access["cdecl"], name)

    def __init__(self):
        self.other_dirs = []

    def __call__(self, libname):
        """Given the name of a library, load it."""
        paths = self.getpaths(libname)

        for path in paths:
            try:
                return self.Lookup(path)
            except:
                pass

        raise ImportError("Could not load %s." % libname)

    def getpaths(self, libname):
        """Return a list of paths where the library might be found."""
        if os.path.isabs(libname):
            yield libname
        else:
            # search through a prioritized series of locations for the library

            # we first search any specific directories identified by user
            for dir_i in self.other_dirs:
                for fmt in self.name_formats:
                    # dir_i should be absolute already
                    yield os.path.join(dir_i, fmt % libname)

            # then we search the directory where the generated python interface is stored
            for fmt in self.name_formats:
                yield os.path.abspath(os.path.join(os.path.dirname(__file__), fmt % libname))

            # now, use the ctypes tools to try to find the library
            for fmt in self.name_formats:
                path = ctypes.util.find_library(fmt % libname)
                if path:
                    yield path

            # then we search all paths identified as platform-specific lib paths
            for path in self.getplatformpaths(libname):
                yield path

            # Finally, we'll try the users current working directory
            for fmt in self.name_formats:
                yield os.path.abspath(os.path.join(os.path.curdir, fmt % libname))

    def getplatformpaths(self, libname):
        return []


# Darwin (Mac OS X)


class DarwinLibraryLoader(LibraryLoader):
    name_formats = [
        "lib%s.dylib",
        "lib%s.so",
        "lib%s.bundle",
        "%s.dylib",
        "%s.so",
        "%s.bundle",
        "%s",
    ]

    class Lookup(LibraryLoader.Lookup):
        # Darwin requires dlopen to be called with mode RTLD_GLOBAL instead
        # of the default RTLD_LOCAL.  Without this, you end up with
        # libraries not being loadable, resulting in "Symbol not found"
        # errors
        mode = ctypes.RTLD_GLOBAL

    def getplatformpaths(self, libname):
        if os.path.pathsep in libname:
            names = [libname]
        else:
            names = [format % libname for format in self.name_formats]

        for dir in self.getdirs(libname):
            for name in names:
                yield os.path.join(dir, name)

    def getdirs(self, libname):
        """Implements the dylib search as specified in Apple documentation:

        http://developer.apple.com/documentation/DeveloperTools/Conceptual/
            DynamicLibraries/Articles/DynamicLibraryUsageGuidelines.html

        Before commencing the standard search, the method first checks
        the bundle's ``Frameworks`` directory if the application is running
        within a bundle (OS X .app).
        """

        dyld_fallback_library_path = _environ_path("DYLD_FALLBACK_LIBRARY_PATH")
        if not dyld_fallback_library_path:
            dyld_fallback_library_path = [os.path.expanduser("~/lib"), "/usr/local/lib", "/usr/lib"]

        dirs = []

        if "/" in libname:
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))
        else:
            dirs.extend(_environ_path("LD_LIBRARY_PATH"))
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))

        if hasattr(sys, "frozen") and sys.frozen == "macosx_app":
            dirs.append(os.path.join(os.environ["RESOURCEPATH"], "..", "Frameworks"))

        dirs.extend(dyld_fallback_library_path)

        return dirs


# Posix


class PosixLibraryLoader(LibraryLoader):
    _ld_so_cache = None

    _include = re.compile(r"^\s*include\s+(?P<pattern>.*)")

    class _Directories(dict):
        def __init__(self):
            self.order = 0

        def add(self, directory):
            if len(directory) > 1:
                directory = directory.rstrip(os.path.sep)
            # only adds and updates order if exists and not already in set
            if not os.path.exists(directory):
                return
            o = self.setdefault(directory, self.order)
            if o == self.order:
                self.order += 1

        def extend(self, directories):
            for d in directories:
                self.add(d)

        def ordered(self):
            return (i[0] for i in sorted(self.items(), key=lambda D: D[1]))

    def _get_ld_so_conf_dirs(self, conf, dirs):
        """
        Recursive funtion to help parse all ld.so.conf files, including proper
        handling of the `include` directive.
        """

        try:
            with open(conf) as f:
                for D in f:
                    D = D.strip()
                    if not D:
                        continue

                    m = self._include.match(D)
                    if not m:
                        dirs.add(D)
                    else:
                        for D2 in glob.glob(m.group("pattern")):
                            self._get_ld_so_conf_dirs(D2, dirs)
        except IOError:
            pass

    def _create_ld_so_cache(self):
        # Recreate search path followed by ld.so.  This is going to be
        # slow to build, and incorrect (ld.so uses ld.so.cache, which may
        # not be up-to-date).  Used only as fallback for distros without
        # /sbin/ldconfig.
        #
        # We assume the DT_RPATH and DT_RUNPATH binary sections are omitted.

        directories = self._Directories()
        for name in (
            "LD_LIBRARY_PATH",
            "SHLIB_PATH",  # HPUX
            "LIBPATH",  # OS/2, AIX
            "LIBRARY_PATH",  # BE/OS
        ):
            if name in os.environ:
                directories.extend(os.environ[name].split(os.pathsep))

        self._get_ld_so_conf_dirs("/etc/ld.so.conf", directories)

        bitage = platform.architecture()[0]

        unix_lib_dirs_list = []
        if bitage.startswith("64"):
            # prefer 64 bit if that is our arch
            unix_lib_dirs_list += ["/lib64", "/usr/lib64"]

        # must include standard libs, since those paths are also used by 64 bit
        # installs
        unix_lib_dirs_list += ["/lib", "/usr/lib"]
        if sys.platform.startswith("linux"):
            # Try and support multiarch work in Ubuntu
            # https://wiki.ubuntu.com/MultiarchSpec
            if bitage.startswith("32"):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ["/lib/i386-linux-gnu", "/usr/lib/i386-linux-gnu"]
            elif bitage.startswith("64"):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ["/lib/x86_64-linux-gnu", "/usr/lib/x86_64-linux-gnu"]
            else:
                # guess...
                unix_lib_dirs_list += glob.glob("/lib/*linux-gnu")
        directories.extend(unix_lib_dirs_list)

        cache = {}
        lib_re = re.compile(r"lib(.*)\.s[ol]")
        ext_re = re.compile(r"\.s[ol]$")
        for dir in directories.ordered():
            try:
                for path in glob.glob("%s/*.s[ol]*" % dir):
                    file = os.path.basename(path)

                    # Index by filename
                    cache_i = cache.setdefault(file, set())
                    cache_i.add(path)

                    # Index by library name
                    match = lib_re.match(file)
                    if match:
                        library = match.group(1)
                        cache_i = cache.setdefault(library, set())
                        cache_i.add(path)
            except OSError:
                pass

        self._ld_so_cache = cache

    def getplatformpaths(self, libname):
        if self._ld_so_cache is None:
            self._create_ld_so_cache()

        result = self._ld_so_cache.get(libname, set())
        for i in result:
            # we iterate through all found paths for library, since we may have
            # actually found multiple architectures or other library types that
            # may not load
            yield i


# Windows


class WindowsLibraryLoader(LibraryLoader):
    name_formats = ["%s.dll", "lib%s.dll", "%slib.dll", "%s"]

    class Lookup(LibraryLoader.Lookup):
        def __init__(self, path):
            super(WindowsLibraryLoader.Lookup, self).__init__(path)
            self.access["stdcall"] = ctypes.windll.LoadLibrary(path)


# Platform switching

# If your value of sys.platform does not appear in this dict, please contact
# the Ctypesgen maintainers.

loaderclass = {
    "darwin": DarwinLibraryLoader,
    "cygwin": WindowsLibraryLoader,
    "win32": WindowsLibraryLoader,
    "msys": WindowsLibraryLoader,
}

load_library = loaderclass.get(sys.platform, PosixLibraryLoader)()


def add_library_search_dirs(other_dirs):
    """
    Add libraries to search paths.
    If library paths are relative, convert them to absolute with respect to this
    file's directory
    """
    for F in other_dirs:
        if not os.path.isabs(F):
            F = os.path.abspath(F)
        load_library.other_dirs.append(F)


del loaderclass

# End loader

add_library_search_dirs([])

# No libraries

# No modules

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 97
class struct_tag_detection_t(Structure):
    pass

struct_tag_detection_t._pack_ = 1
struct_tag_detection_t.__slots__ = [
    'magic_number',
    'id',
    'size_m',
    'timestamp_ns',
    'name',
    'loc_type',
    'T_tag_wrt_cam',
    'R_tag_to_cam',
    'T_tag_wrt_fixed',
    'R_tag_to_fixed',
    'cam',
    'reserved',
]
struct_tag_detection_t._fields_ = [
    ('magic_number', c_uint32),
    ('id', c_int32),
    ('size_m', c_float),
    ('timestamp_ns', c_int64),
    ('name', c_char * int(64)),
    ('loc_type', c_int),
    ('T_tag_wrt_cam', c_float * int(3)),
    ('R_tag_to_cam', (c_float * int(3)) * int(3)),
    ('T_tag_wrt_fixed', c_float * int(3)),
    ('R_tag_to_fixed', (c_float * int(3)) * int(3)),
    ('cam', c_char * int(64)),
    ('reserved', c_int),
]

tag_detection_t = struct_tag_detection_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 97

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 144
for _lib in _libs.values():
    if not _lib.has("pipe_validate_tag_detection_t", "cdecl"):
        continue
    pipe_validate_tag_detection_t = _lib.get("pipe_validate_tag_detection_t", "cdecl")
    pipe_validate_tag_detection_t.argtypes = [String, c_int, POINTER(c_int)]
    pipe_validate_tag_detection_t.restype = POINTER(tag_detection_t)
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 156
for _lib in _libs.values():
    if not _lib.has("pipe_tag_location_type_to_string", "cdecl"):
        continue
    pipe_tag_location_type_to_string = _lib.get("pipe_tag_location_type_to_string", "cdecl")
    pipe_tag_location_type_to_string.argtypes = [c_int]
    pipe_tag_location_type_to_string.restype = c_char_p
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 213
class struct_camera_image_metadata_t(Structure):
    pass

struct_camera_image_metadata_t._pack_ = 1
struct_camera_image_metadata_t.__slots__ = [
    'magic_number',
    'timestamp_ns',
    'frame_id',
    'width',
    'height',
    'size_bytes',
    'stride',
    'exposure_ns',
    'gain',
    'format',
    'framerate',
    'reserved',
]
struct_camera_image_metadata_t._fields_ = [
    ('magic_number', c_uint32),
    ('timestamp_ns', c_int64),
    ('frame_id', c_int32),
    ('width', c_int16),
    ('height', c_int16),
    ('size_bytes', c_int32),
    ('stride', c_int32),
    ('exposure_ns', c_int32),
    ('gain', c_int16),
    ('format', c_int16),
    ('framerate', c_int16),
    ('reserved', c_int16),
]

camera_image_metadata_t = struct_camera_image_metadata_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 213

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 225
for _lib in _libs.values():
    if not _lib.has("pipe_image_format_to_string", "cdecl"):
        continue
    pipe_image_format_to_string = _lib.get("pipe_image_format_to_string", "cdecl")
    pipe_image_format_to_string.argtypes = [c_int]
    pipe_image_format_to_string.restype = c_char_p
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 255
class struct_tof_data_t(Structure):
    pass

struct_tof_data_t._pack_ = 1
struct_tof_data_t.__slots__ = [
    'magic_number',
    'timestamp_ns',
    'points',
    'noises',
    'grayValues',
    'confidences',
]
struct_tof_data_t._fields_ = [
    ('magic_number', c_uint32),
    ('timestamp_ns', c_int64),
    ('points', (c_float * int(3)) * int((224 * 172))),
    ('noises', c_float * int((224 * 172))),
    ('grayValues', c_uint8 * int((224 * 172))),
    ('confidences', c_uint8 * int((224 * 172))),
]

tof_data_t = struct_tof_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 255

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 303
for _lib in _libs.values():
    if not _lib.has("pipe_validate_tof_data_t", "cdecl"):
        continue
    pipe_validate_tof_data_t = _lib.get("pipe_validate_tof_data_t", "cdecl")
    pipe_validate_tof_data_t.argtypes = [String, c_int, POINTER(c_int)]
    pipe_validate_tof_data_t.restype = POINTER(tof_data_t)
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 344
class struct_tof2_data_t(Structure):
    pass

struct_tof2_data_t._pack_ = 1
struct_tof2_data_t.__slots__ = [
    'magic_number',
    'timestamp_ns',
    'width',
    'height',
    'reserved1',
    'reserved2',
    'points',
    'noises',
    'grayValues',
    'confidences',
]
struct_tof2_data_t._fields_ = [
    ('magic_number', c_uint32),
    ('timestamp_ns', c_int64),
    ('width', c_int16),
    ('height', c_int16),
    ('reserved1', c_int16),
    ('reserved2', c_int16),
    ('points', (c_float * int(3)) * int((240 * 180))),
    ('noises', c_float * int((240 * 180))),
    ('grayValues', c_uint8 * int((240 * 180))),
    ('confidences', c_uint8 * int((240 * 180))),
]

tof2_data_t = struct_tof2_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 344

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 391
for _lib in _libs.values():
    if not _lib.has("pipe_validate_tof2_data_t", "cdecl"):
        continue
    pipe_validate_tof2_data_t = _lib.get("pipe_validate_tof2_data_t", "cdecl")
    pipe_validate_tof2_data_t.argtypes = [String, c_int, POINTER(c_int)]
    pipe_validate_tof2_data_t.restype = POINTER(tof2_data_t)
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 428
class struct_imu_data_t(Structure):
    pass

struct_imu_data_t._pack_ = 1
struct_imu_data_t.__slots__ = [
    'magic_number',
    'accl_ms2',
    'gyro_rad',
    'temp_c',
    'timestamp_ns',
]
struct_imu_data_t._fields_ = [
    ('magic_number', c_uint32),
    ('accl_ms2', c_float * int(3)),
    ('gyro_rad', c_float * int(3)),
    ('temp_c', c_float),
    ('timestamp_ns', c_uint64),
]

imu_data_t = struct_imu_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 428

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 477
for _lib in _libs.values():
    if not _lib.has("pipe_validate_imu_data_t", "cdecl"):
        continue
    pipe_validate_imu_data_t = _lib.get("pipe_validate_imu_data_t", "cdecl")
    pipe_validate_imu_data_t.argtypes = [String, c_int, POINTER(c_int)]
    pipe_validate_imu_data_t.restype = POINTER(imu_data_t)
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 526
class struct_point_cloud_metadata_t(Structure):
    pass

struct_point_cloud_metadata_t._pack_ = 1
struct_point_cloud_metadata_t.__slots__ = [
    'magic_number',
    'timestamp_ns',
    'n_points',
    'format',
    'id',
    'server_name',
    'reserved',
]
struct_point_cloud_metadata_t._fields_ = [
    ('magic_number', c_uint32),
    ('timestamp_ns', c_int64),
    ('n_points', c_uint32),
    ('format', c_uint32),
    ('id', c_uint32),
    ('server_name', c_char * int(32)),
    ('reserved', c_uint32),
]

point_cloud_metadata_t = struct_point_cloud_metadata_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 526

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 530
for _lib in _libs.values():
    if not _lib.has("pipe_point_cloud_format_to_string", "cdecl"):
        continue
    pipe_point_cloud_format_to_string = _lib.get("pipe_point_cloud_format_to_string", "cdecl")
    pipe_point_cloud_format_to_string.argtypes = [c_int]
    pipe_point_cloud_format_to_string.restype = c_char_p
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 545
for _lib in _libs.values():
    if not _lib.has("pipe_point_cloud_meta_to_size_bytes", "cdecl"):
        continue
    pipe_point_cloud_meta_to_size_bytes = _lib.get("pipe_point_cloud_meta_to_size_bytes", "cdecl")
    pipe_point_cloud_meta_to_size_bytes.argtypes = [point_cloud_metadata_t]
    pipe_point_cloud_meta_to_size_bytes.restype = c_int
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 654
class struct_pose_4dof_t(Structure):
    pass

struct_pose_4dof_t._pack_ = 1
struct_pose_4dof_t.__slots__ = [
    'magic_number',
    'timestamp_ns',
    'p',
    'yaw',
]
struct_pose_4dof_t._fields_ = [
    ('magic_number', c_uint32),
    ('timestamp_ns', c_int64),
    ('p', c_double * int(3)),
    ('yaw', c_double),
]

pose_4dof_t = struct_pose_4dof_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 654

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 703
for _lib in _libs.values():
    if not _lib.has("pipe_validate_pose_4dof_t", "cdecl"):
        continue
    pipe_validate_pose_4dof_t = _lib.get("pipe_validate_pose_4dof_t", "cdecl")
    pipe_validate_pose_4dof_t.argtypes = [String, c_int, POINTER(c_int)]
    pipe_validate_pose_4dof_t.restype = POINTER(pose_4dof_t)
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 740
class struct_pose_vel_6dof_t(Structure):
    pass

struct_pose_vel_6dof_t._pack_ = 1
struct_pose_vel_6dof_t.__slots__ = [
    'magic_number',
    'timestamp_ns',
    'T_child_wrt_parent',
    'R_child_to_parent',
    'v_child_wrt_parent',
    'w_child_wrt_child',
]
struct_pose_vel_6dof_t._fields_ = [
    ('magic_number', c_uint32),
    ('timestamp_ns', c_int64),
    ('T_child_wrt_parent', c_float * int(3)),
    ('R_child_to_parent', (c_float * int(3)) * int(3)),
    ('v_child_wrt_parent', c_float * int(3)),
    ('w_child_wrt_child', c_float * int(3)),
]

pose_vel_6dof_t = struct_pose_vel_6dof_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 740

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 789
for _lib in _libs.values():
    if not _lib.has("pipe_validate_pose_vel_6dof_t", "cdecl"):
        continue
    pipe_validate_pose_vel_6dof_t = _lib.get("pipe_validate_pose_vel_6dof_t", "cdecl")
    pipe_validate_pose_vel_6dof_t.argtypes = [String, c_int, POINTER(c_int)]
    pipe_validate_pose_vel_6dof_t.restype = POINTER(pose_vel_6dof_t)
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 981
class struct_vio_data_t(Structure):
    pass

struct_vio_data_t._pack_ = 1
struct_vio_data_t.__slots__ = [
    'magic_number',
    'quality',
    'timestamp_ns',
    'T_imu_wrt_vio',
    'R_imu_to_vio',
    'pose_covariance',
    'vel_imu_wrt_vio',
    'velocity_covariance',
    'imu_angular_vel',
    'gravity_vector',
    'T_cam_wrt_imu',
    'R_cam_to_imu',
    'error_code',
    'n_feature_points',
    'state',
    'frame',
]
struct_vio_data_t._fields_ = [
    ('magic_number', c_uint32),
    ('quality', c_int32),
    ('timestamp_ns', c_int64),
    ('T_imu_wrt_vio', c_float * int(3)),
    ('R_imu_to_vio', (c_float * int(3)) * int(3)),
    ('pose_covariance', c_float * int(21)),
    ('vel_imu_wrt_vio', c_float * int(3)),
    ('velocity_covariance', c_float * int(21)),
    ('imu_angular_vel', c_float * int(3)),
    ('gravity_vector', c_float * int(3)),
    ('T_cam_wrt_imu', c_float * int(3)),
    ('R_cam_to_imu', (c_float * int(3)) * int(3)),
    ('error_code', c_uint32),
    ('n_feature_points', c_uint16),
    ('state', c_uint8),
    ('frame', c_uint8),
]

vio_data_t = struct_vio_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 981

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1030
for _lib in _libs.values():
    if not _lib.has("pipe_validate_vio_data_t", "cdecl"):
        continue
    pipe_validate_vio_data_t = _lib.get("pipe_validate_vio_data_t", "cdecl")
    pipe_validate_vio_data_t.argtypes = [String, c_int, POINTER(c_int)]
    pipe_validate_vio_data_t.restype = POINTER(vio_data_t)
    break

enum_vio_point_quality_t = c_int# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1042

LOW = 0# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1042

MEDIUM = (LOW + 1)# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1042

HIGH = (MEDIUM + 1)# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1042

vio_point_quality_t = enum_vio_point_quality_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1042

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1054
class struct_vio_feature_t(Structure):
    pass

struct_vio_feature_t._pack_ = 1
struct_vio_feature_t.__slots__ = [
    'id',
    'cam_id',
    'pix_loc',
    'tsf',
    'p_tsf',
    'depth',
    'depth_error_stddev',
    'point_quality',
]
struct_vio_feature_t._fields_ = [
    ('id', c_uint32),
    ('cam_id', c_int32),
    ('pix_loc', c_float * int(2)),
    ('tsf', c_float * int(3)),
    ('p_tsf', (c_float * int(3)) * int(3)),
    ('depth', c_float),
    ('depth_error_stddev', c_float),
    ('point_quality', vio_point_quality_t),
]

vio_feature_t = struct_vio_feature_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1054

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1073
class struct_ext_vio_data_t(Structure):
    pass

struct_ext_vio_data_t._pack_ = 1
struct_ext_vio_data_t.__slots__ = [
    'v',
    'last_cam_frame_id',
    'last_cam_timestamp_ns',
    'imu_cam_time_shift_s',
    'gravity_covariance',
    'gyro_bias',
    'accl_bias',
    'n_total_features',
    'features',
]
struct_ext_vio_data_t._fields_ = [
    ('v', vio_data_t),
    ('last_cam_frame_id', c_int32),
    ('last_cam_timestamp_ns', c_int64),
    ('imu_cam_time_shift_s', c_float),
    ('gravity_covariance', (c_float * int(3)) * int(3)),
    ('gyro_bias', c_float * int(3)),
    ('accl_bias', c_float * int(3)),
    ('n_total_features', c_uint32),
    ('features', vio_feature_t * int(64)),
]

ext_vio_data_t = struct_ext_vio_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1073

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1107
for _lib in _libs.values():
    if not _lib.has("pipe_validate_ext_vio_data_t", "cdecl"):
        continue
    pipe_validate_ext_vio_data_t = _lib.get("pipe_validate_ext_vio_data_t", "cdecl")
    pipe_validate_ext_vio_data_t.argtypes = [String, c_int, POINTER(c_int)]
    pipe_validate_ext_vio_data_t.restype = POINTER(ext_vio_data_t)
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1116
for _lib in _libs.values():
    if not _lib.has("pipe_print_vio_state", "cdecl"):
        continue
    pipe_print_vio_state = _lib.get("pipe_print_vio_state", "cdecl")
    pipe_print_vio_state.argtypes = [c_int]
    pipe_print_vio_state.restype = None
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1125
for _lib in _libs.values():
    if not _lib.has("pipe_print_vio_error", "cdecl"):
        continue
    pipe_print_vio_error = _lib.get("pipe_print_vio_error", "cdecl")
    pipe_print_vio_error.argtypes = [c_uint32]
    pipe_print_vio_error.restype = None
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1144
for _lib in _libs.values():
    if not _lib.has("pipe_construct_vio_error_string", "cdecl"):
        continue
    pipe_construct_vio_error_string = _lib.get("pipe_construct_vio_error_string", "cdecl")
    pipe_construct_vio_error_string.argtypes = [c_uint32, String, c_size_t]
    pipe_construct_vio_error_string.restype = c_int
    break

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1171
class struct_vfc_data_t(Structure):
    pass

struct_vfc_data_t._pack_ = 1
struct_vfc_data_t.__slots__ = [
    'magic_number',
    'altitude_ok',
    'flow_ok',
    'position_ok',
    'backtrack_seconds',
]
struct_vfc_data_t._fields_ = [
    ('magic_number', c_uint32),
    ('altitude_ok', c_bool),
    ('flow_ok', c_bool),
    ('position_ok', c_bool),
    ('backtrack_seconds', c_float),
]

vfc_data_t = struct_vfc_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1171

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1207
for _lib in _libs.values():
    if not _lib.has("pipe_validate_vfc_data_t", "cdecl"):
        continue
    pipe_validate_vfc_data_t = _lib.get("pipe_validate_vfc_data_t", "cdecl")
    pipe_validate_vfc_data_t.argtypes = [String, c_int, POINTER(c_int)]
    pipe_validate_vfc_data_t.restype = POINTER(vfc_data_t)
    break

# <built-in>
try:
    __FLT_MIN__ = 1.1754943508222875e-38
except:
    pass

# /usr/lib/gcc/x86_64-linux-gnu/7/include/float.h: 121
try:
    FLT_MIN = __FLT_MIN__
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 45
try:
    TAG_DETECTION_MAGIC_NUMBER = 1448040524
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 67
try:
    N_TAG_LOCATION_TYPES = 4
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 69
try:
    TAG_LOCATION_UNKNOWN = 0
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 70
try:
    TAG_LOCATION_FIXED = 1
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 71
try:
    TAG_LOCATION_STATIC = 2
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 72
try:
    TAG_LOCATION_DYNAMIC = 3
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 75
try:
    TAG_NAME_LEN = 64
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 110
try:
    TAG_DETECTION_RECOMMENDED_READ_BUF_SIZE = (sizeof(tag_detection_t) * 16)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 118
try:
    TAG_DETECTION_RECOMMENDED_PIPE_SIZE = (64 * 1024)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 169
try:
    CAMERA_MAGIC_NUMBER = 1448040524
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 175
try:
    IMAGE_FORMAT_RAW8 = 0
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 176
try:
    IMAGE_FORMAT_NV12 = 1
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 177
try:
    IMAGE_FORMAT_STEREO_RAW8 = 2
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 178
try:
    IMAGE_FORMAT_H264 = 3
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 179
try:
    IMAGE_FORMAT_H265 = 4
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 180
try:
    IMAGE_FORMAT_RAW16 = 5
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 181
try:
    IMAGE_FORMAT_NV21 = 6
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 182
try:
    IMAGE_FORMAT_JPG = 7
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 183
try:
    IMAGE_FORMAT_YUV422 = 8
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 184
try:
    IMAGE_FORMAT_YUV420 = 9
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 185
try:
    IMAGE_FORMAT_RGB = 10
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 186
try:
    IMAGE_FORMAT_FLOAT32 = 11
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 187
try:
    IMAGE_FORMAT_STEREO_NV21 = 12
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 188
try:
    IMAGE_FORMAT_STEREO_RGB = 13
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 189
try:
    IMAGE_FORMAT_YUV422_UYVY = 14
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 190
try:
    IMAGE_FORMAT_STEREO_NV12 = 15
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 191
try:
    IMAGE_FORMAT_RAW10 = 16
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 192
try:
    IMAGE_FORMAT_RAW12 = 17
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 242
try:
    TOF_MAGIC_NUMBER = 1448040524
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 244
try:
    MPA_TOF_WIDTH = 224
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 245
try:
    MPA_TOF_HEIGHT = 172
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 246
try:
    MPA_TOF_SIZE = (MPA_TOF_WIDTH * MPA_TOF_HEIGHT)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 269
try:
    TOF_RECOMMENDED_READ_BUF_SIZE = (sizeof(tof_data_t) * 4)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 276
try:
    TOF_RECOMMENDED_PIPE_SIZE = ((1024 * 1024) * 64)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 322
try:
    TOF2_MAGIC_NUMBER = (1448040524 + 1)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 324
try:
    MPA_MAX_TOF2_WIDTH = 240
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 325
try:
    MPA_MAX_TOF2_HEIGHT = 180
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 326
try:
    MPA_MAX_TOF2_SIZE = (MPA_MAX_TOF2_WIDTH * MPA_MAX_TOF2_HEIGHT)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 358
try:
    TOF2_RECOMMENDED_READ_BUF_SIZE = (sizeof(tof2_data_t) * 4)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 365
try:
    TOF2_RECOMMENDED_PIPE_SIZE = ((1024 * 1024) * 64)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 407
try:
    IMU_MAGIC_NUMBER = 1448040524
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 415
try:
    IMU_INVALID_TEMPERATURE_VALUE = FLT_MIN
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 443
try:
    IMU_RECOMMENDED_READ_BUF_SIZE = (sizeof(imu_data_t) * 400)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 451
try:
    IMU_RECOMMENDED_PIPE_SIZE = (128 * 1024)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 508
try:
    POINT_CLOUD_MAGIC_NUMBER = 1448040524
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 510
try:
    POINT_CLOUD_FORMAT_FLOAT_XYZ = 0
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 511
try:
    POINT_CLOUD_FORMAT_FLOAT_XYZC = 1
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 512
try:
    POINT_CLOUD_FORMAT_FLOAT_XYZRGB = 2
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 513
try:
    POINT_CLOUD_FORMAT_FLOAT_XYZCRGB = 3
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 514
try:
    POINT_CLOUD_FORMAT_FLOAT_XY = 4
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 515
try:
    POINT_CLOUD_FORMAT_FLOAT_XYC = 5
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 629
try:
    POSE_4DOF_MAGIC_NUMBER = 1448040524
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 668
try:
    POSE_4DOF_RECOMMENDED_READ_BUF_SIZE = (sizeof(pose_4dof_t) * 23)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 677
try:
    POSE_4DOF_RECOMMENDED_PIPE_SIZE = (64 * 1024)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 722
try:
    POSE_VEL_6DOF_MAGIC_NUMBER = 1448040524
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 754
try:
    POSE_6DOF_RECOMMENDED_READ_BUF_SIZE = (sizeof(pose_vel_6dof_t) * 24)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 763
try:
    POSE_6DOF_RECOMMENDED_PIPE_SIZE = (64 * 1024)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 865
try:
    VIO_STATE_FAILED = 0
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 866
try:
    VIO_STATE_INITIALIZING = 1
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 867
try:
    VIO_STATE_OK = 2
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 870
try:
    ERROR_CODE_COVARIANCE = (1 << 0)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 871
try:
    ERROR_CODE_IMU_OOB = (1 << 1)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 872
try:
    ERROR_CODE_IMU_BW = (1 << 2)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 873
try:
    ERROR_CODE_NOT_STATIONARY = (1 << 3)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 874
try:
    ERROR_CODE_NO_FEATURES = (1 << 4)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 875
try:
    ERROR_CODE_CONSTRAINT = (1 << 5)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 876
try:
    ERROR_CODE_FEATURE_ADD = (1 << 6)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 877
try:
    ERROR_CODE_VEL_INST_CERT = (1 << 7)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 878
try:
    ERROR_CODE_VEL_WINDOW_CERT = (1 << 8)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 879
try:
    ERROR_CODE_DROPPED_IMU = (1 << 10)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 880
try:
    ERROR_CODE_BAD_CAM_CAL = (1 << 11)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 881
try:
    ERROR_CODE_LOW_FEATURES = (1 << 12)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 882
try:
    ERROR_CODE_DROPPED_CAM = (1 << 13)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 883
try:
    ERROR_CODE_DROPPED_GPS_VEL = (1 << 14)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 884
try:
    ERROR_CODE_BAD_TIMESTAMP = (1 << 15)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 885
try:
    ERROR_CODE_IMU_MISSING = (1 << 16)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 886
try:
    ERROR_CODE_CAM_MISSING = (1 << 17)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 887
try:
    ERROR_CODE_CAM_BAD_RES = (1 << 18)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 888
try:
    ERROR_CODE_CAM_BAD_FORMAT = (1 << 19)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 889
try:
    ERROR_CODE_UNKNOWN = (1 << 20)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 890
try:
    ERROR_CODE_STALLED = (1 << 21)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 911
try:
    VIO_FRAME_UNKNOWN = 0
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 912
try:
    VIO_FRAME_IMU_UNALIGNED = 1
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 913
try:
    VIO_FRAME_BODY_ALIGNED = 2
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 927
try:
    RESET_VIO_SOFT = 'reset_vio_soft'
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 928
try:
    RESET_VIO_HARD = 'reset_vio_hard'
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 938
try:
    VIO_MAGIC_NUMBER = 88429860
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 995
try:
    VIO_RECOMMENDED_READ_BUF_SIZE = (sizeof(vio_data_t) * 26)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1004
try:
    VIO_RECOMMENDED_PIPE_SIZE = (64 * 1024)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1035
try:
    VIO_MAX_REPORTED_FEATURES = 64
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1081
try:
    EXT_VIO_RECOMMENDED_READ_BUF_SIZE = (sizeof(ext_vio_data_t) * 10)
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1158
try:
    VFC_MAGIC_NUMBER = 88429861
except:
    pass

# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1182
try:
    VFC_RECOMMENDED_READ_BUF_SIZE = (sizeof(vfc_data_t) * 32)
except:
    pass

tag_detection_t = struct_tag_detection_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 97

camera_image_metadata_t = struct_camera_image_metadata_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 213

tof_data_t = struct_tof_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 255

tof2_data_t = struct_tof2_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 344

imu_data_t = struct_imu_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 428

point_cloud_metadata_t = struct_point_cloud_metadata_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 526

pose_4dof_t = struct_pose_4dof_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 654

pose_vel_6dof_t = struct_pose_vel_6dof_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 740

vio_data_t = struct_vio_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 981

vio_feature_t = struct_vio_feature_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1054

ext_vio_data_t = struct_ext_vio_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1073

vfc_data_t = struct_vfc_data_t# /builds/voxl-public/voxl-sdk/core-libs/libmodal-pipe/library/include/modal_pipe_interfaces.h: 1171

# No inserted files

# No prefix-stripping

